class Action:
    
    PREACTION = 0
    POSTACTION = 1
    
    #Pre: action is a none empty String, kind is PREACTION or POSTACTION
    #Post: constructs a Action object
    #comment: 
    def __init__(self,action,kind,id=None,order=-1):
        self.action = action
        self.kind = kind
        self.id = id
        self.order = order
    
    #Pre: action is a none empty String
    #Post: sets new action String to this object
    #comment: Use sentenceUpdate in the database to update the database information    
    def setAction(self,action):
        if len(action) > 0:
            self.action = action
    
    #Pre: 
    #Post: returns the object action String
    #comment:
    def getAction(self):
        return self.action
    
    #Pre:
    #Post: returns the Action id
    #comment: returns None if no id is set
    def getId(self):
        return self.id
    
    #Pre:
    #Post: returns Action kind
    #comment: PREACTION or POSTACTION
    def getKind(self):
        return self.kind
    
    #Pre: kind is PREACTION or POSTACTION
    #Post: sets a new kind for this object
    #comment: Use sentenceUpdate in the database to update the database information
    def setKind(self,kind):
        if kind == self.PREACTION or kind == self.POSTACTION:
            self.kind = kind
    
    #Pre:
    #Post: returns the object order
    #comment:    
    def getOrder(self):
        return self.order
    
    #Pre: order is a Integer
    #Post: sets a new order value
    #comment:
    def setOrder(self,order):
        self.order = order
    
    #Pre:
    #Post:
    #comment: To String   
    def __str__(self):
        string = ""
        if self.kind == self.PREACTION:
            string += "Pre: "
        else:
            string += "Post: "
        
        string += "("+str(self.id)+") "
        
        string += self.action
        
        return string
            
    