from PyQt4 import QtCore, QtGui
import sqlalchemy
from Database import Database
from sqlalchemy import *
import shutil
import os.path
from datetime import datetime
import sys
import os.path
from Action import Action
from Link import Link
from Sentence import Sentence
from Property import Property
from threading import Thread

class Ui_Converter2to3(object):
    def setupUi(self, Converter2to3):
        Converter2to3.setObjectName("Converter2to3")
        Converter2to3.resize(506, 102)
        self.centralwidget = QtGui.QWidget(Converter2to3)
        self.centralwidget.setObjectName("centralwidget")
        self.horizontalLayoutWidget = QtGui.QWidget(self.centralwidget)
        self.horizontalLayoutWidget.setGeometry(QtCore.QRect(0, 0, 501, 80))
        self.horizontalLayoutWidget.setObjectName("horizontalLayoutWidget")
        self.horizontalLayout = QtGui.QHBoxLayout(self.horizontalLayoutWidget)
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.verticalLayout = QtGui.QVBoxLayout()
        self.verticalLayout.setObjectName("verticalLayout")
        self.Database = QtGui.QLabel(self.horizontalLayoutWidget)
        self.Database.setObjectName("Database")
        self.verticalLayout.addWidget(self.Database)
        self.progressBar = QtGui.QProgressBar(self.horizontalLayoutWidget)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.progressBar.sizePolicy().hasHeightForWidth())
        self.progressBar.setSizePolicy(sizePolicy)
        self.progressBar.setTextVisible(True)
        
                
        self.verticalLayout.addWidget(self.progressBar)
        self.horizontalLayout.addLayout(self.verticalLayout)
        self.verticalLayout_2 = QtGui.QVBoxLayout()
        self.verticalLayout_2.setObjectName("verticalLayout_2")
        self.OpenButton = QtGui.QPushButton(self.horizontalLayoutWidget)
        self.OpenButton.setObjectName("OpenButton")
        self.verticalLayout_2.addWidget(self.OpenButton)
        self.ConvertButton = QtGui.QPushButton(self.horizontalLayoutWidget)
        self.ConvertButton.setObjectName("ConvertButton")
        self.verticalLayout_2.addWidget(self.ConvertButton)
        self.horizontalLayout.addLayout(self.verticalLayout_2)
        Converter2to3.setCentralWidget(self.centralwidget)
        self.statusBar = QtGui.QStatusBar(Converter2to3)
        self.statusBar.setObjectName("statusBar")
        Converter2to3.setStatusBar(self.statusBar)

        self.retranslateUi(Converter2to3)
        QtCore.QMetaObject.connectSlotsByName(Converter2to3)

    def retranslateUi(self, Converter2to3):
        Converter2to3.setWindowTitle(QtGui.QApplication.translate("Converter2to3", "Converter2to3", None, QtGui.QApplication.UnicodeUTF8))
        self.Database.setText(QtGui.QApplication.translate("Converter2to3", "Database:", None, QtGui.QApplication.UnicodeUTF8))
        
        self.OpenButton.setText(QtGui.QApplication.translate("Converter2to3", "Open", None, QtGui.QApplication.UnicodeUTF8))
        self.ConvertButton.setText(QtGui.QApplication.translate("Converter2to3", "Convert", None, QtGui.QApplication.UnicodeUTF8))

class conversionThread(Thread):
    
    def __init__(self,oldDB,filename,progressBar,statusBar,doneFunction): 
        Thread.__init__(self)
        self.oldDatabase = oldDB
        self.filename = filename
        
        
        self.progressBar = progressBar
        self.statusBar = statusBar
        self.doneFunction = doneFunction
        
    def run(self):
        newDB = Database(False)
        newDB.createNewDatabase(str(self.filename))
        self.statusBar.showMessage("Opened new Database: "+str(self.filename))
        
        
        self.oldDatabase.fillAllSentences()
        
        property = Property('avatar_type','User')
        userSentences = self.oldDatabase.getAllSentencesUser()
        
        convertDict = dict()
        
        self.progressBar.setRange(0,len(userSentences))
        self.progressBar.setValue(0)
        self.statusBar.showMessage("Converting user sentences")
        for us in userSentences:
            
            uSentence = self.oldDatabase.getSentence(us[0], self.oldDatabase.REPLY_USER)
            newSentence = Sentence(uSentence.getSentence())
            
            newSentence.addProperty(property)
            audio = Property('audio_url',uSentence.getAudioUrl())
            newSentence.addProperty(audio)
            
            if not uSentence.getPreAction() == None and len(uSentence.getPreAction()) > 0:
                preAction = Action(uSentence.getPreAction(),Action.PREACTION)
                newSentence.addPreAction(preAction)
                
            if not uSentence.getPostAction() == None and len(uSentence.getPostAction()) > 0:
                postAction = Action(uSentence.getPostAction(),Action.POSTACTION)
                newSentence.addPostAction(postAction)
            
            newSentence = newDB.updateSentence(newSentence)
            
            
            
            convertDict[str(uSentence.getId())] = newSentence.getId()
            self.progressBar.setValue(self.progressBar.value()+1)
            
        self.statusBar.showMessage("Converted all user sentences")    
            
        #computer sentences
        property = Property('avatar_type','Computer') 
        computerSentences = self.oldDatabase.getAllSentencesComputer()
        self.progressBar.setValue(0) 
        self.progressBar.setRange(0,len(computerSentences))
        self.statusBar.showMessage("Converting computer sentences")
        for us in computerSentences:
            uSentence = self.oldDatabase.getSentence(us[0], self.oldDatabase.REPLY_COMPUTER)
            newSentence = Sentence(uSentence.getSentence())
            
            newSentence.addProperty(property)
            audio = Property('audio_url',uSentence.getAudioUrl())
            newSentence.addProperty(audio)
            
            if not uSentence.getPreAction() == None and len(uSentence.getPreAction()) > 0:
                preAction = Action(uSentence.getPreAction(),Action.PREACTION)
                newSentence.addPreAction(preAction)
                
            if not uSentence.getPostAction() == None and len(uSentence.getPostAction()) > 0:
                postAction = Action(uSentence.getPostAction(),Action.POSTACTION)
                newSentence.addPostAction(postAction)
            
            newSentence = newDB.updateSentence(newSentence)
            
            convertDict[str(uSentence.getId())] = newSentence.getId()
            self.progressBar.setValue(self.progressBar.value()+1)
        self.statusBar.showMessage("Converted all computer sentences")
        
        #setRoot
        root = self.oldDatabase.getRootSentence()
        
        if not root == None:
            rId = root.getId()
            property = Property('is_root','1')
            sentence = newDB.getSentenceById(convertDict[str(rId)])
            sentence.addProperty(property)
            newDB.updateSentence(sentence)
         
        self.statusBar.showMessage("Added the root") 
                   
        #convertLinks
        keys = convertDict.keys()
        self.progressBar.setValue(0)
        self.progressBar.setRange(0,len(keys))
        self.statusBar.showMessage("Converting links")
        for key in keys:
            
            links = self.oldDatabase.getAllReplys(key,"NA")
            for link in links:
                newLink = Link(convertDict[str(key)],convertDict[str(link.getId())])
                
                newDB.addNewLink(newLink)
            self.progressBar.setValue(self.progressBar.value()+1)
            
        self.statusBar.showMessage("converted all Links")
        
        self.statusBar.showMessage("Conversion completed")     
        self.doneFunction()

class Converter2to3(QtGui.QMainWindow, Ui_Converter2to3):
    
    def __init__(self):
        QtGui.QMainWindow.__init__(self)
        self.setupUi(self)
        
        self.connect(self.OpenButton,QtCore.SIGNAL('clicked()'),self.openOldDatabase)
        self.connect(self.ConvertButton,QtCore.SIGNAL('clicked()'),self.convertDatabase)
        self.ConvertButton.setEnabled(False)
        
        self.oldDatabase = None
        
        
    def openOldDatabase(self):
        
        filename = QtGui.QFileDialog.getOpenFileName(self, "Select Editor2 generated db3", "*.db3")
        if not filename == None and len(filename) > 0 and os.path.isfile(filename):
            
            self.loadOldDatabase(filename)
            self.oldName = str(filename)
            
    def loadOldDatabase(self,filename):
        self.oldDatabase = OldDatabase(str(filename))
        
        self.ConvertButton.setEnabled(True)
        self.statusBar.showMessage("Loaded database: "+str(filename))  
           
    def convertDatabase(self):
        filename = QtGui.QFileDialog.getSaveFileName(self, "Select location and filename", "*.db3")
        if not filename == None and len(filename) > 0:
            if not self.oldName == str(filename):
                if os.path.isfile(filename):
                    reply = QtGui.QMessageBox.question(self, 'Save as',"File already exist this will append the data to the file if valid db3: "+str(filename)+"?", QtGui.QMessageBox.Yes, QtGui.QMessageBox.Cancel)
                    
                    if reply == QtGui.QMessageBox.Yes:
                    
                        self.convertOldDatabaseTo(filename)
                else:
                    self.convertOldDatabaseTo(filename)
            else:
                QtGui.QMessageBox.warning(self,"Warning","Cannot override the old database: "+str(filename))
                
                
    def convertOldDatabaseTo(self,filename):
        self.OpenButton.setEnabled(False)
        self.ConvertButton.setEnabled(False)
        
        
        thread = conversionThread(self.oldDatabase,filename,self.progressBar,self.statusBar,self.conversionDone)
        
        thread.start()
        
    def conversionDone(self):       
        self.OpenButton.setEnabled(True)
        self.ConvertButton.setEnabled(True)
        


class OldSentence():
    
    #Sentence contructor 
    def __init__(self,sentence,sentence_id=None,kind=0,preAction="",postAction="",audioUrl=""):
        self.sentence = sentence
        self.id = sentence_id
        self.kind = kind
        self.preAction= preAction
        self.postAction = postAction
        self.actionChange = False
        self.audioUrl = audioUrl
        self.replys = []
        
    #adds sentence id of replying sentence    
    def addReply(self,other_sentence_id):
        self.replys.append(other_sentence_id)
    
    #adds sentence ids of replying sentences    
    def addReplys(self,other_sentence_ids):
        for reply in other_sentence_ids:
            self.addReply(reply)
    
    #returns a empty list if no reply's
    #returns a list of int id's of reply sentences
    def getReplys(self):
        return self.replys
     
    def isUpdated(self):
        return not self.actionChange
    
    #returns string sentence
    def getSentence(self):
        return self.sentence
    
    #returns int id of sentence
    def getSentenceId(self):
        return self.id
    
    #sets int id of sentence
    def setId(self,id):
        self.id = id
    
    #returns int id of sentence same as getSentenceId
    def getId(self):
        return self.getSentenceId()
    
    #returns the kind of the sentence.
    #static int from Database
    def getKind(self):
        return self.kind
    
    #sets the kind of the sentence
    #static int from Database
    def setKind(self,kind):
        self.kind = kind
    
    #returns the preAction string of the sentence
    def getPreAction(self):
        return self.preAction
    
    #returns the postAction string of the sentence
    def getPostAction(self):
        return self.postAction
    
    
    
    #sets the postAction string of the sentence
    #if other postAction then the status of the sentence class is put on not uptodate
    def setPostAction(self,action):
        if self.postAction == action:
            pass
        else:  
            self.postAction = action
            self.actionChange = True
    
    #sets the preAction string of the sentence
    #if other preAction then the status of the sentence class is put on not uptodate
    def setPreAction(self,action): 
        if self.preAction == action:
            pass
        else:  
            self.preAction = action
            self.actionChange = True       
    
    #sets the AudioUrl 
    #changes the class status to not uptodate
    def setAudioUrl(self,url):
        self.audioUrl = url
        self.actionChange = True
    
    #returns string reprensetation of the audioUrl    
    def getAudioUrl(self):
        return self.audioUrl
    
    #default toString    
    def __str__(self):
        return self.sentence+" | "+str(self.kind)
    
    #sets a new sentence String
    #if sentence has lenght smaller or equal to 0 the update is ignored 
    def setSentence(self, sen):
        if len(sen) > 0:
            self.sentence = sen
        else:
            print "trying to set empty sentence for: "+str(self.id)+" | "+self.sentence

class OldDatabase():

    def __init__(self,name):
        
        if not name == None or not name == "":
            
        
            self.name = name
            #backup or create database file
            self.backup()
            
            print "init"
            self.allSentencesListUser = []
            self.allSentencesListComputer = []
            self.createTestEngine()
            
            #Computer reply's
            self.ROOT_COMPUTER = 0
            self.END_COMPUTER = 1
            self.REPLY_COMPUTER = 2
            #user reply's
            self.REPLY_USER = 5
            self.ROOT_USER = 3
            self.END_USER = 4
        else:
            print "no database name given"
    
    def fillAllSentences(self):
        self.allSentencesListUser = []
        self.allSentencesListComputer = []
        s = select([self.sentence_table])
        result = self.engine.execute(s)
        r = result.fetchall()
        for i in r:
            if int(i['kind']) >= 3:
                self.allSentencesListUser.append((i['id'],i['sentence']))
            else:
                self.allSentencesListComputer.append((i['id'],i['sentence']))                
        
    def getAllSentencesUser(self):
        #print str(self.allSentencesList)
        return self.allSentencesListUser
    
    def getAllSentencesComputer(self):
        return self.allSentencesListComputer
    
    def backup(self):
        
        databaseUrl = self.name
        
        #check if file exist
        if not os.path.exists(databaseUrl) or not os.path.isfile(databaseUrl):
            #create file
            file = open(databaseUrl,"w")
            file.close()

        
        #make backup 
        date = datetime.now()
        dtuple = date.timetuple()
        backupUrl = self.name+str(dtuple[2])+"-"+str(dtuple[1])+"-"+str(dtuple[0])+" "+str(dtuple[3])+"_"+str(dtuple[4])+".bak"
        shutil.copy(databaseUrl, backupUrl)
        
    def createTestEngine(self):
        print "initializing.."
        databaseUrl = self.name
        print databaseUrl
        self.engine = create_engine("sqlite:///"+databaseUrl, echo=False)
        
        metadata = MetaData()
        self.sentence_table = Table('sentence', metadata,Column('id', Integer, primary_key=True), Column('sentence', String),Column('audio_url', String,default=""),Column('pre_action_string', String,default=""),Column('post_action_string',String,default=""),Column('kind',Integer,default=0))
        self.link_table = Table('link',metadata,Column('left',Integer, ForeignKey('sentence.id'),primary_key=True),Column('right',Integer,ForeignKey('sentence.id'),primary_key=True)) 
        metadata.create_all(self.engine)
        
        print "succes"
        self.fillAllSentences()
        

        
    
    def update(self, sentence):
        #check if in database
        if sentence.id == None:
            #no id yet insert into database check on sentence already in database
            id = self.insertNewSentence(sentence)
            sentence.setId(id)
            
        else:
            #Check if id is in the database
            s = select([self.sentence_table], self.sentence_table.c.id==sentence.id)
        
            result = self.engine.execute(s)
            r = result.fetchall()
            result.close()
            if len(r) > 0:
                #id found
                line = r[0]
                
                
                if line['id'] == sentence.id:            
                    if not sentence.isUpdated() or not line['sentence'] == sentence.getSentence():
                        self.updateSentence(sentence.id, sentence)
                    
                else:
                    print "anomily detected wrong sentence id found"
                    
            else:
                result.close()
                print "anomily detected sentence id was not found "+str(sentence.id)+" : "+sentence.getSentence()
                id = self.insertNewSentence(sentence)
                sentence.setId(id)
                
        self.fillAllSentences()
    
    #returns id
    def insertNewSentence(self,pSentence):
        #insert new sentence into database checks if equal sentence isn't already in the database
        
        #s = select([self.sentence_table], and_(func.upper(self.sentence_table.c.sentence)==pSentence.getSentence().upper(),self.sentence_table.c.kind==pSentence.getKind()))
        
        #result = self.engine.execute(s)
        
        #id = result.fetchall()
        #if len(id) > 0:
            #return id[0]['id']
        
        #result.close()
        result = self.engine.execute(self.sentence_table.insert(), sentence=pSentence.getSentence(), kind=pSentence.getKind(),audio_url=pSentence.getAudioUrl(),pre_action_string=pSentence.getPreAction(),post_action_string=pSentence.getPostAction())
        
        id = result.last_inserted_ids()
        #print "id: "+str(id)
        result.close()
        self.fillAllSentences()
        return id[0]
    
    #disused
    def insertNewLinks(self,links,sentenceId):
        for link in links:
            s = select([self.link_table],_and(self.link_table.c.left==link,self.link_table.c.right==sentenceId))
            result = self.engine.execute(s)
            if len(result.fetchall()) > 0:
                #then do nothing link already in database (shouldn't happen)
                print 'anomaly link already in the database' 
                result.close()
            else:
                result.close()
                insertNewLink(link,sentenceId)
            
        
    def insertNewLink(self,pLeft,pRight):
        #create and insert new replyTo link
        try:
            self.engine.execute(self.link_table.insert(), left=pLeft ,right=pRight)
        except:
            print "Error inserting link, link probably already exist"
            
    def removeLinks(self,links,sentenceId):
        for link in links:
            removeLink(link,sentenceId)
    
    def removeLink(self,pLeft,pRight,alsoSentence,alsoOrphans):
        #remove link from database
        conn = self.engine.connect()
        conn.execute(self.link_table.delete().where(and_(self.link_table.c.left==pLeft,self.link_table.c.right==pRight)))
        
        if alsoSentence and alsoOrphans:
            #remove sentence
            conn.execute(self.sentence_table.delete().where(self.sentence_table.c.id==pRight))
            #Check if there more orphaned sentences
            s = select([self.link_table],self.link_table.c.left==pRight)
            result = conn.execute(s)
    
            links = result.fetchall()
            for link in links:
                self.removeLink(pRight,link['right'],alsoSentence,alsoOrphans)
                
        elif alsoSentence:
            #remove sentence
            conn.execute(self.sentence_table.delete().where(self.sentence_table.c.id==pRight))
            #remove old links to sentence
            conn.execute(self.link_table.delete().where(self.link_table.c.right==pRight))
            #remove old links from sentence
            conn.execute(self.link_table.delete().where(self.link_table.c.left==pRight))
        elif alsoOrphans:
            #check if pReply_id has become orphaned
            s = select([self.link_table],self.link_table.c.right==pRight)
            result = conn.execute(s)
        
            links = result.fetchall()
            if len(links) > 0:
                #sentence not orphaned
                return
            else:
                #remove sentence
                conn.execute(self.sentence_table.delete().where(self.sentence_table.c.id==pRight))
                               
                
                #Check if there more orphaned sentences
                s = select([self.link_table],self.link_table.c.left==pRight)
                result = conn.execute(s)
        
                links = result.fetchall()
                for link in links:
                    self.removeLink(pRight,link['right'],alsoSentence,alsoOrphans)
        
    def updateSentence(self,pId,sen):
        conn = self.engine.connect()
        conn.execute(self.sentence_table.update().where(self.sentence_table.c.id==pId).values(sentence=sen.getSentence(),audio_url=sen.getAudioUrl(),pre_action_string=sen.getPreAction(),post_action_string=sen.getPostAction()))
        self.fillAllSentences()
        
    def getRootSentence(self):
        s = select([self.sentence_table],self.sentence_table.c.kind==self.ROOT_COMPUTER)
        result = self.engine.execute(s)
        r = result.fetchall()
        if len(r) > 0:
            
            result.close()
            print r
            return self.getSentence(r[0]['id'],self.ROOT_COMPUTER)
        else:
            print "Adding new root sentence"
            sen = OldSentence("root sentence")
            sen.setKind(self.ROOT_COMPUTER)
            self.update(sen)
            
            return self.getRootSentence()
    
    def getAllComputerSentences(self):
        s = select([self.sentence_table],self.sentence_table.c.kind < 3)
        result = self.engine.execute(s)
        r = result.fetchall()
        sentenceList = []
        for item in r:
            res = self.getSentence(item['id'],2)
            if not res == None:
                sentenceList.append(res)
                
        return sentenceList
        
    def getSentence(self,sentenceId,kind):
        s = select([self.sentence_table],self.sentence_table.c.id==sentenceId)
        result = self.engine.execute(s)
        r = result.fetchall()
        result.close()
        if len(r) > 0:
            sen = r[0]
            
            
            
            sentence = OldSentence(sen['sentence'],sentenceId,kind,sen['pre_action_string'],sen['post_action_string'],sen['audio_url'])
            return sentence
        else:
            print "Sentence wasn't found id: "+str(sentenceId)    
            return None
        
    def getAllReplys(self,sentenceId,kind):
        s = select([self.link_table],self.link_table.c.left==sentenceId)
        result = self.engine.execute(s)
        replys = []
        for reply in result.fetchall():
            app = self.getSentence(reply['right'],kind)
            if not app == None:
                replys.append(app)
        
        result.close()
        return replys
    
    def getParents(self,id):
        s = select([self.link_table],self.link_table.c.right==id)
        result = self.engine.execute(s)
        parents = []
        for parent in result.fetchall():
            parents.append(parent['left'])
        
        result.close()
        return parents
     
    def removeSentence(self,sentenceId,kind):
        conn = self.engine.connect()          
        #remove all links leading to sentence
        conn.execute(self.link_table.delete().where(self.link_table.c.reply==sentenceId))
        
        #remove all links leading of sentence
        conn.execute(self.link_table.delete().where(self.link_table.c.replyTo==sentenceId))
        
        #remove sentence
        conn.execute(self.sentence_table.delete().where(self.sentence_table.c.id==sentenceId))
        
        self.fillAllSentences()
    
    #disused
    def getOrphanedSentences(self):  
        s1 = select([self.sentence_table,self.link_table],self.sentence_table.c.id==self.link_table.c.reply)
        result = self.engine.execute(s1)
        
        withLink = []
        r = result.fetchall()
        result.close()
        for linked in r:
            try:
                withLink.index(linked['id'])
            except:
                withLink.append(linked['id'])
        
        s2 = select([self.sentence_table])
        result = self.engine.execute(s2)
        withOutLink = []
        r = result.fetchall()
        result.close()
        for sen in r:
            try:
                withLink.index(sen['id'])
            except:
                withOutLink.append((sen['id'],sen['sentence']))
        
        print "linked: "+str(withLink)
        print "orphan: "+str(withOutLink)
        
        return withOutLink
        
    def __str__(self):
        terug  = "Sentences: \n"
        
        s = select([self.sentence_table])
        result = self.engine.execute(s)
        rows = result.fetchall()
        for row in rows:
            terug += str(row['id'])+": "+row['sentence']+" \n"
        
        terug += "============= \n Links: \n"
        result.close()
        s = select([self.link_table])
        result = self.engine.execute(s)
        rows = result.fetchall()
        for row in rows:
            terug += str(row['replyTo'])+" | "+str(row['reply'])+" | "+str(row['kind'])+ " \n"
        
        result.close()    
        return terug

    
if __name__ == '__main__':
                                
    app = QtGui.QApplication(sys.argv)
    main = Converter2to3()
    main.show()
    sys.exit(app.exec_())
        