# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'DialogReader.ui'
#
# Created: Tue Jun 16 14:45:00 2009
#      by: PyQt4 UI code generator 4.4.4
#
# WARNING! All changes made in this file will be lost!

from PyQt4 import QtCore, QtGui
from StoryWidget import StoryWidget
from StoryLineWidget import StoryLineWidget
from insertDialogWindow import insertDialogWindow
from random import randint

class Ui_DialogReader(object):
    def setupUi(self, DialogReader):
        DialogReader.setObjectName("DialogReader")
        DialogReader.resize(640, 629)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(DialogReader.sizePolicy().hasHeightForWidth())
        DialogReader.setSizePolicy(sizePolicy)
        DialogReader.setSizeGripEnabled(True)
        DialogReader.setModal(True)
        self.verticalLayout_2 = QtGui.QVBoxLayout(DialogReader)
        self.verticalLayout_2.setObjectName("verticalLayout_2")
        self.verticalLayout = QtGui.QVBoxLayout()
        self.verticalLayout.setObjectName("verticalLayout")
        self.horizontalLayout = QtGui.QHBoxLayout()
        self.horizontalLayout.setObjectName("horizontalLayout")
        self.RootButton = QtGui.QPushButton(DialogReader)
        self.RootButton.setObjectName("RootButton")
        self.connect(self.RootButton,QtCore.SIGNAL('clicked()'),self.chooseRoot)
        self.horizontalLayout.addWidget(self.RootButton)
        
        self.RandomizeButton = QtGui.QPushButton(DialogReader)
        self.RandomizeButton.setObjectName("RandomizeButton")
        self.connect(self.RandomizeButton,QtCore.SIGNAL('clicked()'),self.randomFillIn)
        self.horizontalLayout.addWidget(self.RandomizeButton)
        
        spacerItem = QtGui.QSpacerItem(40, 20, QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Minimum)
        self.horizontalLayout.addItem(spacerItem)
        self.ClearButton = QtGui.QPushButton(DialogReader)
        self.ClearButton.setObjectName("ClearButton")
        self.connect(self.ClearButton,QtCore.SIGNAL('clicked()'),QtCore.SLOT('close()'))
        self.horizontalLayout.addWidget(self.ClearButton)
        self.verticalLayout.addLayout(self.horizontalLayout)
        self.scrollArea = QtGui.QScrollArea(DialogReader)
        self.scrollArea.setWidgetResizable(True)
        self.scrollArea.setObjectName("scrollArea")
        self.scrollAreaWidgetContents = StoryWidget(self.scrollArea)
        self.scrollAreaWidgetContents.setGeometry(QtCore.QRect(0, 0, 618, 574))
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.scrollAreaWidgetContents.sizePolicy().hasHeightForWidth())
        self.scrollAreaWidgetContents.setSizePolicy(sizePolicy)
        self.scrollAreaWidgetContents.setObjectName("scrollAreaWidgetContents")
        self.scrollArea.setWidget(self.scrollAreaWidgetContents)
        self.verticalLayout.addWidget(self.scrollArea)
        self.verticalLayout_2.addLayout(self.verticalLayout)

        self.retranslateUi(DialogReader)
        QtCore.QMetaObject.connectSlotsByName(DialogReader)

    def retranslateUi(self, DialogReader):
        DialogReader.setWindowTitle(QtGui.QApplication.translate("DialogReader", "Dialog Reader", None, QtGui.QApplication.UnicodeUTF8))
        self.RootButton.setText(QtGui.QApplication.translate("DialogReader", "Root", None, QtGui.QApplication.UnicodeUTF8))
        self.RandomizeButton.setText(QtGui.QApplication.translate("DialogReader", "Random", None, QtGui.QApplication.UnicodeUTF8))
        self.ClearButton.setText(QtGui.QApplication.translate("DialogReader", "Close", None, QtGui.QApplication.UnicodeUTF8))

class DialogReader(QtGui.QDialog,Ui_DialogReader):
    
    def __init__(self,parent,engine):
        QtGui.QDialog.__init__(self,parent)
        self.setupUi(self)
        self.engine = engine
        self.database = self.engine.getDatabase()
        self.chooseRoot()
        
    def chooseRoot(self):
        self.clearVariables()
        
        roots = self.database.getRootSentences()
        rootId = None
        if len(roots) > 1:
            itemList = []
            idList = dict()
            for root in roots:
                rootString = root.getSentence()+" ["+str(root.getId())+"]"
                idList[rootString] = root.getId()
                itemList.append(rootString)
            
            dialog = insertDialogWindow(self,"Select Root","Search:","Select",itemList,True,None)
            dialog.exec_()
            
            result = dialog.getResult()
            if result == None:
                self.chooseRoot()
            else:
                rootId = idList[result]
        else:
            if len(roots) == 1:
                rootId = roots[0].getId()
        
        if not rootId == None:
            more , storyLine = self.createStoryLineWidget(rootId,len(self.storyList))
            self.storyList.append(rootId)
            self.scrollAreaWidgetContents.addStoryLine(storyLine)
            
            if not more:
                self.addNext()
            
    def clearVariables(self):
        self.storyList = []
        self.scrollAreaWidgetContents = StoryWidget(self.scrollArea)
        self.scrollArea.setWidget(self.scrollAreaWidgetContents)
    
    def addNext(self):
        if len(self.storyList) > 0:
            parentId  = self.storyList[len(self.storyList)-1]
            parentSentence = self.database.getSentenceById(parentId)
            
            children = parentSentence.getChildren()
            childId = None
            if len(children) > 1:
                r = randint(0,len(children)-1)
                childId = children[r].getReplyId()
            else:
                if len(children) == 1:
                    childId = children[0].getReplyId()
                else:
                    return False
             
            if not childId == None:
                more, storyLine = self.createStoryLineWidget(childId, len(self.storyList))    
                self.storyList.append(childId)
                self.scrollAreaWidgetContents.addStoryLine(storyLine)
                
                if not more:
                    return self.addNext()
                else:
                    return True
            else:
                return False 
            
    def createStoryLineWidget(self,sentenceId,index):
        sentence = self.database.getSentenceById(sentenceId)
        
        actor = sentence.getProperty('avatar_type')
        if not actor == None:
            actor = actor.getValue()
        buttonEnabled = (len(sentence.getChildren()) > 1)
        storyLine = StoryLineWidget(self.scrollAreaWidgetContents,actor,self.engine.getActorList().getActorColor(actor),sentence.getSentence(),self.createStoryLineWidgetFunction(index),buttonEnabled)
        
        return buttonEnabled, storyLine
    
    def createStoryLineWidgetFunction(self,storyListIndex):
        def function():
            self.selectResponse(storyListIndex)
        
        return function
    def selectResponse(self,index):
        if index == len(self.storyList):
            parentId = self.storyList[index]
            parentSentence = self.database.getSentenceById(parentId,True,False)
            
            children = parentSentence.getChildren()
            childId = None
            if len(children) > 1:
                itemList = []
                idList = dict()
                for child in children:
                    childString = child.getReplyPeek()+" ["+str(child.getReplyId())+"]"
                    idList[childString] = child.getReplyId()
                    itemList.append(childString)
                
                dialog = insertDialogWindow(self,"Select Sentence","Search:","Select",itemList,True,None)
                dialog.exec_()
                
                result = dialog.getResult()
                if not result == None:
                    childId = idList[result]
            else:
                if len(children) == 1:
                    childId = children[0].getReplyId()
            
            if not childId == None:
                more , storyLine = self.createStoryLineWidget(childId,len(self.storyList))
                self.storyList.append(childId)
                self.scrollAreaWidgetContents.addStoryLine(storyLine)
                
                if not more:
                    self.addNext()
        else:
            storyListBackup = self.storyList[:index+1]
            self.clearVariables()
            for sti in storyListBackup:
                more, storyLine = self.createStoryLineWidget(sti, len(self.storyList))
                self.storyList.append(sti)
                self.scrollAreaWidgetContents.addStoryLine(storyLine)
            
            parentId = self.storyList[index]
            parentSentence = self.database.getSentenceById(parentId,True,False)
            
            children = parentSentence.getChildren()
            childId = None
            if len(children) > 1:
                itemList = []
                idList = dict()
                for child in children:
                    childString = child.getReplyPeek()+" ["+str(child.getReplyId())+"]"
                    idList[childString] = child.getReplyId()
                    itemList.append(childString)
                
                dialog = insertDialogWindow(self,"Select Sentence","Search:","Select",itemList,True,None)
                dialog.exec_()
                
                result = dialog.getResult()
                if not result == None:
                    childId = idList[result]
            else:
                if len(children) == 1:
                    childId = children[0].getReplyId()
            
            if not childId == None:
                more , storyLine = self.createStoryLineWidget(childId,len(self.storyList))
                self.storyList.append(childId)
                self.scrollAreaWidgetContents.addStoryLine(storyLine)
                
                if not more:
                    self.addNext()
                
    def randomFillIn(self):
        while self.addNext():
            pass
    
    def quit(self):
        self.close()
        