from PyQt4 import QtCore, QtGui
from Ui_Editor3CentralWidget import Ui_Editor3CentralWidget
from insertDialogWindow import insertDialogWindow
from optionArea import Ui_optionArea
from scrollArea import Ui_scrollArea

class Editor3CentralWidget(QtGui.QWidget,Ui_Editor3CentralWidget):
    
    def __init__(self,parent,engine):
        QtGui.QWidget.__init__(self,parent)
        self.clearVariables()
        self.mainWindow = parent
        self.engine = engine
        self.setupUi(self)
        self.setPropertyButtonsEnabled(False)
        
        #Functions
        self.connect(self.NewPropertyButton,QtCore.SIGNAL('clicked()'),self.engine.addNewProperty)
        self.connect(self.ExistingPropertyButton,QtCore.SIGNAL('clicked()'),self.engine.addExistingProperty)
        
    def setPropertyButtonsEnabled(self,enable):
        self.NewPropertyButton.setEnabled(enable)
        self.ExistingPropertyButton.setEnabled(enable)
    
    def setView(self,prev,mainSentences,next):
        self.clean()
        #set prev sentence
        if not prev == None:
            self.PreviousPlaceholder.setText(prev.getSentence())
        else:
            self.PreviousPlaceholder.setText("")
        
        if not next == None:
            self.NextPlaceholder.setText(next.getSentence())
        else:
            self.NextPlaceholder.setText("")
        
        viewSentences = self.MainScrollAreaContent.setView(prev,mainSentences)
        self.PropertyScrollAreaContent.setView()
        
        if self.engine.activeSentenceIndex >= 0:
            self.setPropertyButtonsEnabled(True)
        else:
            self.setPropertyButtonsEnabled(False)
        
        return viewSentences
    
    def updatePropertyList(self):
        self.optionArea.setOptions(self.getActiveSentence())
        
    def clean(self):
        self.clearVariables()
        viewSentences = self.MainScrollAreaContent.clean()
        self.PropertyScrollAreaContent.clean()
        
        return viewSentences
    
    def clearVariables(self):
        pass
    
    def saveProperties(self):
        self.PropertyScrollAreaContent.saveProperties()
    
    def updateScreen(self):
        viewSentences = self.MainScrollAreaContent.updateScreen()
        self.PropertyScrollAreaContent.updateScreen()
        return viewSentences   
    
        