'''
Created on 17 jun 2009

@author: Niels
'''
from PyQt4 import QtCore, QtGui
from HistoryWidget import HistoryWidget
from HistoryLineWidget import HistoryLineWidget



class Ui_HistoryDialog(object):
    def setupUi(self, HistoryDialog):
        HistoryDialog.setObjectName("HistoryDialog")
        HistoryDialog.resize(640, 629)
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(HistoryDialog.sizePolicy().hasHeightForWidth())
        HistoryDialog.setSizePolicy(sizePolicy)
        #HistoryDialog.setSizeGripEnabled(True)
        #HistoryDialog.setModal(False)
        self.verticalLayout_2 = QtGui.QVBoxLayout(HistoryDialog)
        self.verticalLayout_2.setObjectName("verticalLayout_2")
        self.verticalLayout = QtGui.QVBoxLayout()
        self.verticalLayout.setObjectName("verticalLayout")
        self.horizontalLayout = QtGui.QHBoxLayout()
        self.horizontalLayout.setObjectName("horizontalLayout")
        #self.RootButton = QtGui.QPushButton(HistoryDialog)
        #self.RootButton.setObjectName("RootButton")
        #self.connect(self.RootButton,QtCore.SIGNAL('clicked()'),self.chooseRoot)
        #self.horizontalLayout.addWidget(self.RootButton)
        
        #self.RandomizeButton = QtGui.QPushButton(HistoryDialog)
        #self.RandomizeButton.setObjectName("RandomizeButton")
        #self.connect(self.RandomizeButton,QtCore.SIGNAL('clicked()'),self.randomFillIn)
        #self.horizontalLayout.addWidget(self.RandomizeButton)
        
        spacerItem = QtGui.QSpacerItem(40, 20, QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Minimum)
        self.horizontalLayout.addItem(spacerItem)
        self.ClearButton = QtGui.QPushButton(HistoryDialog)
        self.ClearButton.setObjectName("ClearButton")
        self.connect(self.ClearButton,QtCore.SIGNAL('clicked()'),QtCore.SLOT('close()'))
        self.horizontalLayout.addWidget(self.ClearButton)
        self.verticalLayout.addLayout(self.horizontalLayout)
        self.scrollArea = QtGui.QScrollArea(HistoryDialog)
        self.scrollArea.setWidgetResizable(True)
        self.scrollArea.setObjectName("scrollArea")
        self.scrollAreaWidgetContents = HistoryWidget(self.scrollArea)
        self.scrollAreaWidgetContents.setGeometry(QtCore.QRect(0, 0, 618, 574))
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Expanding)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.scrollAreaWidgetContents.sizePolicy().hasHeightForWidth())
        self.scrollAreaWidgetContents.setSizePolicy(sizePolicy)
        self.scrollAreaWidgetContents.setObjectName("scrollAreaWidgetContents")
        self.scrollArea.setWidget(self.scrollAreaWidgetContents)
        self.verticalLayout.addWidget(self.scrollArea)
        self.verticalLayout_2.addLayout(self.verticalLayout)

        self.retranslateUi(HistoryDialog)
        QtCore.QMetaObject.connectSlotsByName(HistoryDialog)

    def retranslateUi(self, HistoryDialog):
        HistoryDialog.setWindowTitle(QtGui.QApplication.translate("HistoryDialog", "Dialog Reader", None, QtGui.QApplication.UnicodeUTF8))
        #self.RootButton.setText(QtGui.QApplication.translate("HistoryDialog", "Root", None, QtGui.QApplication.UnicodeUTF8))
        #self.RandomizeButton.setText(QtGui.QApplication.translate("HistoryDialog", "Random", None, QtGui.QApplication.UnicodeUTF8))
        self.ClearButton.setText(QtGui.QApplication.translate("HistoryDialog", "Hide", None, QtGui.QApplication.UnicodeUTF8))

class HistoryDialog(QtGui.QMainWindow,Ui_HistoryDialog):
    
    def __init__(self,parent,engine):
        QtGui.QMainWindow.__init__(self,None)
        screen = QtGui.QDesktopWidget().screenGeometry()
        self.engine = engine
        self.resize(screen.width()/2,screen.height()-100)
        self.centralwidget = QtGui.QWidget(self)
        self.setCentralWidget(self.centralwidget)
        self.setupUi(self.centralwidget)
        self.db = engine.getDatabase()
        self.mainWindow = parent
        self.engine.setHistoryWidget(self)
        self.setWindowTitle("History Window")
            
    def clearVariables(self):
        
        self.scrollAreaWidgetContents = HistoryWidget(self.scrollArea)
        self.scrollArea.setWidget(self.scrollAreaWidgetContents)
    
    def fillInDialog(self,pointList,activePoint):
        self.clearVariables()
        counter = 0
        for point in pointList:
            id = point.getActiveSentenceId()
            active = False
            if activePoint == counter:
                active = True
            widget = self.createStoryLineWidget(id, counter,active)
            self.scrollAreaWidgetContents.addHistoryLine(widget)
            counter += 1
                
    def createStoryLineWidget(self,sentenceId,index,active):
        sentence = self.db.getSentenceById(sentenceId)
        
        actor = sentence.getProperty('avatar_type')
        if not actor == None:
            actor = actor.getValue()
        
        storyLine = HistoryLineWidget(self.scrollAreaWidgetContents,actor,self.engine.getActorList().getActorColor(actor),sentence.getSentence(),self.createStoryLineWidgetFunction(index),len(sentence.getChildren()),active)
        
        return storyLine
    
    def createStoryLineWidgetFunction(self,storyListIndex):
        def function():
            self.jumpTo(storyListIndex)
        
        return function
    
    def jumpTo(self,index):
        self.engine.jumpToHistory(index)
        
    def closeEvent(self,event):
        self.engine.historyWindowClosed()
        event.accept()
    
    def quit(self):
        self.engine.historyWindowClosed()
        self.close()
                
    
        