class Link:
    
    #Pre:reply_to_id and reply_id are Integers (parent, child)
    #Post: constructs a new Link object
    #comment: Sometimes it's useful to set the Peek sentences
    #         If reply_id is still unknown on creation of the link it will be set too None
    #         When the reply sentence gets it's id the reply_id is filled in
    def __init__(self,reply_to_id,reply_id=None,order=-1):
        self.reply_to_id = reply_to_id
        self.reply_id = reply_id
        self.order = order
        
        self.reply_to_sentence = None
        self.reply_sentence = None
    
    #Pre: reply_id is set to -1, sentenceId is a Integer from a existing sentenceId
    #Post: sets the reply_id to sentenceId
    #comment:
    def fillInReplyId(self,sentenceId):
        if self.reply_id == None:
            self.reply_id = sentenceId
            
    #Pre:
    #Post: returns the reply_to_id (parent)
    #comment:      
    def getReplyToId(self):
        return self.reply_to_id
    
    #Pre:
    #Post: returns the reply_id (child)
    #comment:  
    def getReplyId(self):
        return self.reply_id
    
    #Pre: sentence is a String
    #Post: sets the link object reply_to_sentence peak String (parent)
    #comment:  
    def addReplyToPeek(self,sentence):
        self.reply_to_sentence = sentence
    
    #Pre: sentence is a String
    #Post: sets the link object reply_sentence peek String (child)
    #comment:      
    def addReplyPeek(self,sentence):
        self.reply_sentence = sentence
    
    #Pre:
    #Post: returns the reply_to_sentence peek String (parent)
    #comment: sentence could be out dated changes will have no effect on the database
    def getReplyToPeek(self):
        return self.reply_to_sentence
    
    #Pre:
    #Post: returns the reply_sentence peak String (child)
    #comment: sentence could be out dated changes will have no effect on the database 
    def getReplyPeek(self):
        return self.reply_sentence
    
    #Pre: order is a Integer
    #Post: sets a new order value
    #comment: use updateSentence to update the new order value in the database 
    def setOrder(self,order):
        self.order = order
    
    #Pre:
    #Post: returns the order value
    #comment:      
    def getOrder(self):
        return self.order
    
    #Tostring
    def __str__(self):
        if self.reply_sentence == None or self.reply_to_sentence == None:
            return "Link: "+str(self.reply_to_id)+" - "+str(self.reply_id)
        else:
            return "Link: ("+str(self.reply_to_id)+") "+str(self.reply_to_sentence)+" - ("+str(self.reply_id)+") "+str(self.reply_sentence)