class Property:
    
    #Pre: name is a none empty String, value is a none empty String
    #Post: constructs a new Property object 
    #comment:  
    def __init__(self,name,value,id=None,show=None):
        self.name = name
        self.value = str(value)
        self.id = id
        self.show = show
    
    #Pre:
    #Post: returns the object id
    #comment:      
    def getId(self):
        return self.id
    
    #Pre:
    #Post: returns the object name
    #comment:  
    def getName(self):
        return self.name
    
    #Pre: name is a none empty String
    #Post: sets a new name
    #comment: Use updateSentence to update the property name in the database 
    def setName(self,name):
        if len(name) > 0:
            self.name = name
    
    #Pre:
    #Post: returns the object value
    #comment:          
    def getValue(self):
        return self.value
    
    #Pre:
    #Post: sets a new value
    #comment: Use updateSentence to update the property value in the database  
    def setValue(self,value):
        self.value = str(value)
    
    #Pre:
    #Post: returns show value of the property (Database.ENABLED, Database.DISABLED)
    #comment: To change show value of the property use the functions provided in Database class
    #         Can return None if show value is not known
    def getShow(self):
        return self.show
    
    #To String    
    def __str__(self):
        return "("+str(self.id)+") "+self.name+"= "+str(self.value) 
    