from Sentence import Sentence
from exLink import exLink
from Database import Database
from Link import Link
class exSentence(Sentence):
    
    
    def __init__(self,sentence,engine):
        Sentence.__init__(self, sentence.getSentence(), sentence.getId())
        sentenceActor = sentence.getProperty("avatar_type")
        self.engine = engine
       
        self.saved = False
        
        for child in sentence.getChildren():
            childSentence = self.engine.getDatabase().getSentenceById(child.getReplyId(),True,False)
            childActor = childSentence.getProperty("avatar_type")
            if childActor == None:
                childActor = None
            else:
                childActor = childActor.getValue() 
            self.addChild(exLink(child,sentenceActor,childActor,self.engine))
            
        for parent in sentence.getParents():
            parentSentence = self.engine.getDatabase().getSentenceById(parent.getReplyToId(),True,False)
            parentActor = parentSentence.getProperty("avatar_type")
            if parentActor == None:
                pass
            else:
                parentActor = parentActor.getValue()
            self.addParent(exLink(parent,parentActor,sentenceActor,self.engine))
            
        for action in sentence.getPostActionList():
            self.addPostAction(action)
        
        for action in sentence.getPreActionList():
            self.addPreAction(action)
        
        dic = sentence.getPropertyDict()
        
        for property in sentence.getPropertys():
            self.addProperty(dic[property])
            
    def isSaved(self):
        return self.saved
    
    def setSaved(self,saved=True):
        self.saved = saved
        
    def getActor(self):
        actor = self.getProperty("avatar_type")
        if actor == None:
            return None
        else:
            return actor.getValue()
        
    def removeChild(self,childId):
        counter = 0
        for child in self.children:
            if child.getReplyId() == childId:
                del self.children[counter]
                break
            
            counter += 1 

    def __cmp__(self,other):
        if other == None:
            return -1
        try:
            if other.getId() == self.getId():
                return 0
            else:
                return 1
        except:
            return -1
    
    