from PyQt4 import QtCore, QtGui
from insertDialog import Ui_InsertDialog

class insertDialogWindow(QtGui.QDialog,Ui_InsertDialog):
    
    def __init__(self,parent,title,insertLabel,insertButtonLabel,itemList,selectable,result):
        QtGui.QDialog.__init__(self,parent)
        self.title = title
        self.result = result
        self.insertLabel = insertLabel
        self.insertButtonLabel = insertButtonLabel
        self.itemList = itemList 
        self.selectable = selectable
        self.setupUi(self)
        self.selectedIndex = -1
        
        self.listView.addItems(itemList)
        self.listView.setAutoScroll(True)
        if self.selectable:
            self.setEnabled(True)
            self.programmedButton.setEnabled(False)
            self.connect(self.listView,QtCore.SIGNAL("itemClicked (QListWidgetItem *)"),self.itemSelected)
        else:
            self.listView.setEnabled(False)
            self.programmedButton.setEnabled(True)
        
        self.connect(self.DialogEditLine,QtCore.SIGNAL("textEdited (const QString&)"),self.textEdited)
        self.connect(self.programmedButton,QtCore.SIGNAL("clicked()"),self.setResult)
        self.connect(self.CancelButton,QtCore.SIGNAL('clicked()'),self.reject)
    
    def textEdited(self,text):
        text = str(text)
        text = text.strip()
        text = text.lower()
        index = 0
        
        for item in self.itemList:
            lItem = item.lower()
            if lItem.startswith(text):
                if lItem == text:
                    if self.selectable:
                        self.programmedButton.setEnabled(True)
                    else:
                        self.programmedButton.setEnabled(False)
                    break
                else:
                    if self.selectable:
                        print "disable button"
                        self.programmedButton.setEnabled(False)
                    else:
                        self.programmedButton.setEnabled(True)
                    break
            index += 1
        if len(self.itemList) == index:
            if self.selectable:
                self.programmedButton.setEnabled(False)
            else:
                self.programmedButton.setEnabled(True)    
        else:
            selectedItem = self.listView.item(index)
            self.listView.clearSelection()
            self.listView.setItemSelected(selectedItem,True)
            self.listView.scrollTo(self.listView.indexFromItem(selectedItem),QtGui.QAbstractItemView.PositionAtTop)    
        
    def itemSelected(self,item):
        self.DialogEditLine.setText(item.text())
        if self.selectable:
            self.programmedButton.setEnabled(True)
            self.selectedIndex = item.listWidget().row(item)
        else:
            self.programmedButton.setEnabled(False)
        
    def setResult(self):
        
        self.result = str(self.DialogEditLine.text())
        
        self.close()
        
    def getIndex(self):
        return self.selectedIndex
        
    def getResult(self):
        return self.result