from PyQt4 import QtCore, QtGui
from optionList import Ui_optionList

class optionListWidget(QtGui.QWidget,Ui_optionList):
    
    def __init__(self,parent,engine):
        QtGui.QWidget.__init__(self,parent)
        self.engine = engine
        self.optionList = []
        self.shownWidgets = []
        self.setupUi(self)
        
        self.sentence = None
    
    def setView(self):
        if self.engine.activeSentenceIndex >= 0:
            self.sentence = self.engine.exSentences[self.engine.activeSentenceIndex]    
            self.fillInOptions()
            
            self.update()
    
    def fillInOptions(self):
        if not self.sentence == None:
            self.clean()
            options = self.sentence.getPropertys()
            counter = 0
            for option in options:
                
                #print option
                optionLabel1 = QtGui.QLabel(self.formLayoutWidget)
                sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Maximum, QtGui.QSizePolicy.Preferred)
                sizePolicy.setHorizontalStretch(0)
                sizePolicy.setVerticalStretch(0)
                sizePolicy.setHeightForWidth(optionLabel1.sizePolicy().hasHeightForWidth())
                optionLabel1.setSizePolicy(sizePolicy)
                optionLabel1.setMaximumSize(QtCore.QSize(150, 16777215))
                #optionLabel1.setObjectName(str(option))
                optionLabel1.setText(option)
                self.formLayout.setWidget(counter, QtGui.QFormLayout.LabelRole, optionLabel1)
                optionLine1 = QtGui.QLineEdit(self.formLayoutWidget)
                optionLine1.setText(self.sentence.getProperty(option).getValue())
                print str(option)+" "+str(self.sentence.getProperty(option).getShow())
                optionLine1.setEnabled(self.sentence.getProperty(option).getShow() == 1)
                #optionLine1.setObjectName(str(option))
                self.formLayout.setWidget(counter, QtGui.QFormLayout.FieldRole, optionLine1)
                
                self.optionList.append((self.sentence.getProperty(option),optionLine1))
                self.shownWidgets.append(optionLabel1)
                self.shownWidgets.append(optionLine1)
                counter += 1
    
    def clean(self):
        for widget in self.shownWidgets:
            
            self.formLayout.removeWidget(widget)
            #widget.setParent(None)
            widget.deleteLater()
            
            del widget
        
        self.shownWidgets = []
        self.optionList = []
        
    
    def updateScreen(self):
        self.saveProperties()
        self.fillInOptions()
        self.update()
    
    def saveProperties(self):
        
        for option in self.optionList:
            sentenceOption = self.sentence.getProperty(option[0].getName())
            if sentenceOption.getShow() == 1:
                if sentenceOption == None:
                    filled = option[1].text()
                    if len(filled) > 0 and not filled == "Default Value":
                        option[0].setValue(filled)
                        sentence.addProperty(option[0])
                else:
                    filled = option[1].text()
                    if len(filled) > 0 and not filled == "Default Value":
                        sentenceOption.setValue(filled)
                    
           