from PyQt4 import QtCore, QtGui

from smallSentence import smallSentence, nowSentence
from linkControl import linkControl
from sentenceView import sentenceView

class Ui_scrollAreaContent(object):
    
    def setupUi(self, scrollAreaContent):
        scrollAreaContent.setObjectName("scrollAreaContent")
        self.scrollAreaContent = scrollAreaContent
        sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Fixed, QtGui.QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(scrollAreaContent.sizePolicy().hasHeightForWidth())
        scrollAreaContent.setSizePolicy(sizePolicy)
        
        self.gridLayout = QtGui.QGridLayout(scrollAreaContent)
        self.gridLayout.setMargin(15)
        self.gridLayout.setColumnMinimumWidth(0,250)
        self.gridLayout.setColumnMinimumWidth(1,500)
        
        
        self.retranslateUi(scrollAreaContent)
        QtCore.QMetaObject.connectSlotsByName(scrollAreaContent)

    def retranslateUi(self, scrollAreaContent):
        scrollAreaContent.setWindowTitle(QtGui.QApplication.translate("scrollAreaContent", "Form", None, QtGui.QApplication.UnicodeUTF8))


class scrollAreaContent(QtGui.QWidget,Ui_scrollAreaContent):
    
    def __init__(self,parent,engine):
        QtGui.QWidget.__init__(self,parent)
        self.engine = engine
        self.prevSentence = None
        self.prevWidget = None
        self.activeSentence = None
        self.nowSentences = []

        self.shownWidgets = []
        self.setupUi(self)
    
    def setView(self,prev,mainSentences):
        self.prevSentence = prev
        self.mainSentences = mainSentences
        
        self.orderCollumns()
        
        return self.viewSentences
    
    def updateScreen(self):
        
        self.orderCollumns()
        return self.viewSentences
    
    def orderCollumns(self):
        self.clean()
        #print "ordercollumns"
        rows = 0
        for sentence in self.mainSentences:
            rows += len(sentence.getChildrenOrdered())
            if len(sentence.getChildrenOrdered()) == 0:
                rows += 1
        
        
        if not self.prevSentence == None:
            widget = smallSentence(self.scrollAreaContent,self.prevSentence,None,self.engine)
        
            #AlignmentFlag
            self.gridLayout.addWidget(widget,0,0,rows,1,QtCore.Qt.AlignCenter)
            
            self.shownWidgets.append(widget)
        
        counter = 0 
        index = 0   
        for sentence in self.mainSentences:
            
            #add Frame
            frame = QtGui.QFrame(self.scrollAreaContent)
            sizePolicy = QtGui.QSizePolicy(QtGui.QSizePolicy.Expanding, QtGui.QSizePolicy.Expanding)
            sizePolicy.setHorizontalStretch(0)
            sizePolicy.setVerticalStretch(0)
            sizePolicy.setHeightForWidth(frame.sizePolicy().hasHeightForWidth())
            frame.setSizePolicy(sizePolicy)
            frame.setFrameShape(QtGui.QFrame.StyledPanel)
            frame.setFrameShadow(QtGui.QFrame.Raised)
            
            
            
            widget = None
            activeSentenceId = self.engine.getActiveSentenceId()
            if not activeSentenceId == -1 and  sentence.getId() == activeSentenceId:
                widget = sentenceView(self.scrollAreaContent,sentence,index,self.engine)
                               
                frame.setFrameShadow(QtGui.QFrame.Sunken)
                #print "set active"
            else:
                widget = nowSentence(self.scrollAreaContent,sentence,index,self.engine)
            span = 1
            if len(sentence.getChildrenOrdered()) > 1:
                span = len(sentence.getChildrenOrdered())
            
            self.gridLayout.addWidget(frame,counter,1,span,3)
            self.shownWidgets.append(frame)
            self.viewSentences.append(widget)
            
            self.gridLayout.addWidget(widget,counter,1,span,1,QtCore.Qt.AlignCenter)
            self.shownWidgets.append(widget)
            
            
            
            
            for child in sentence.getChildrenOrdered():
                control = linkControl(self.scrollAreaContent,index,child.getReplyId(),self.engine)
                sen = smallSentence(self.scrollAreaContent,child,sentence.getId(),self.engine)
                
                self.gridLayout.addWidget(control,counter,2,QtCore.Qt.AlignCenter)
                self.gridLayout.addWidget(sen,counter,3,QtCore.Qt.AlignVCenter)
                self.shownWidgets.append(control)
                self.shownWidgets.append(sen)
                counter += 1
            
            index += 1
            
            if len(sentence.getChildren()) == 0:
                counter += 1                   
                
    def clean(self):
        
        for widget in self.shownWidgets:
            
            self.gridLayout.removeWidget(widget)
            #widget.setParent(None)
            widget.deleteLater()
            
            del widget

        
        self.shownWidgets = []
        
        self.scrollAreaContent.update()
        self.viewSentences = []


    