from PyQt4 import QtCore, QtGui
from insertDialogWindow import insertDialogWindow
from Action import Action
from Ui_sentenceView import Ui_SentenceViewFrame
from Property import Property
from Action import Action

class sentenceView(QtGui.QFrame,Ui_SentenceViewFrame):
    


    def __init__(self,parent,sentence,index,engine):
        QtGui.QFrame.__init__(self,parent)
        self.parent = parent
        self.exSentence = sentence
        self.engine = engine
        self.sentenceIndex = index
        
        self.setupUi(self)
        
        self.updateScreen()
        
        #set button function
        
        #combobox
        self.parent.connect(self.ActorComboBox,QtCore.SIGNAL('currentIndexChanged(const QString&)'),self.actorChanged)
        
        #pre
        self.parent.connect(self.PreAddButton,QtCore.SIGNAL('clicked()'),self.newPreAction())
        self.parent.connect(self.PreExistingButton,QtCore.SIGNAL('clicked()'),self.existingPreAction())
        self.parent.connect(self.PreRemoveButton,QtCore.SIGNAL('clicked()'),self.removePreAction())
        self.parent.connect(self.PreUpButton,QtCore.SIGNAL('clicked()'),self.preActionUp())
        self.parent.connect(self.PreDownButton,QtCore.SIGNAL('clicked()'),self.preActionDown())
        
        #Post
        self.parent.connect(self.PostAddButton,QtCore.SIGNAL('clicked()'),self.newPostAction())
        self.parent.connect(self.PostExistingButton,QtCore.SIGNAL('clicked()'),self.existingPostAction())
        self.parent.connect(self.PostRemoveButton,QtCore.SIGNAL('clicked()'),self.removePostAction())
        self.parent.connect(self.PostUpButton,QtCore.SIGNAL('clicked()'),self.postActionUp())
        self.parent.connect(self.PostDownButton,QtCore.SIGNAL('clicked()'),self.postActionDown())
        
        #link
        self.parent.connect(self.NewLinkButton, QtCore.SIGNAL('clicked()'),self.engine.createNewLinkFunction(self.sentenceIndex))
        self.parent.connect(self.ExistingLinkButton, QtCore.SIGNAL('clicked()'),self.engine.createExistingLinkFunction(self.sentenceIndex))
        
        #Save
        self.parent.connect(self.SaveSentenceButton, QtCore.SIGNAL('clicked()'),self.engine.createRevertBackSentenceFunction(self.sentenceIndex))
        
        #Remove
        self.parent.connect(self.RemoveSentenceButton, QtCore.SIGNAL('clicked()'),self.engine.createRemoveSentenceFunction(self.sentenceIndex))
        
        
        #set button icons
        self.PreUpButton.setIcon(QtGui.QIcon("upArrow.png"))
        self.PreDownButton.setIcon(QtGui.QIcon("downArrow.png"))
        self.PostUpButton.setIcon(QtGui.QIcon("upArrow.png"))
        self.PostDownButton.setIcon(QtGui.QIcon("downArrow.png"))
        
        self.SentenceLineEdit.setText(self.exSentence.getSentence())
    
    def actorChanged(self,actor):
        if actor == "<new>":
            itemList = self.engine.getActorList().getActorList()
            insertDialog = insertDialogWindow(self.parent,"New Actor:","Actor:","add",itemList,False,None)
            
            insertDialog.exec_()
            
            result = insertDialog.getResult()
            if not result == None and len(result) > 0:
                actor = result
            else:
                actor = ""
                self.ActorComboBox.setCurrentIndex(0)
        
        property = self.exSentence.getProperty('avatar_type')
        
        if property == None and len(actor) > 0:
            property = Property('avatar_type',actor)
            self.exSentence.addProperty(property)
            self.updateScreen()
        elif not property.getValue() == actor and len(actor) > 0:
            property.setValue(actor)
            self.updateScreen()
        
    def newPreAction(self):
        def function():
            itemList = self.engine.getAllActions()
            insertDialog = insertDialogWindow(self.parent,"New PreAction","PreAction:","add",itemList,False,None)
            
            insertDialog.exec_()
            
            result = insertDialog.getResult()
            if not result == None and len(result) > 0:
                self.exSentence.addPreAction(Action(result,Action.PREACTION,order=self.PreActionList.count()))
                self.updateScreen()
            
        return function
    
    def save(self):
        sentenceString = str(self.SentenceLineEdit.text())
        
       
        isEmptyProperty = self.exSentence.getProperty('is_empty')
        if isEmptyProperty == None:
            isEmptyProperty = Property('is_empty','1')
            self.exSentence.addProperty(isEmptyProperty)
        
        if len(sentenceString) > 0 and not sentenceString == "Empty Sentence":
            
            isEmptyProperty.setValue('0')
        else:
           
            isEmptyProperty.setValue('1')
        self.exSentence.setSentence(sentenceString)
        avatarTypeProperty = self.exSentence.getProperty('avatar_type')
        if avatarTypeProperty == None:
            avatarTypeProperty = Property("avatar_type","Default Value")
            self.exSentence.addProperty(avatarTypeProperty)
        avatarTypeProperty.setValue(self.ActorComboBox.currentText())
        
              
    
    def existingPreAction(self):
        def function():
            itemList = self.engine.getAllActions()
            insertDialog = insertDialogWindow(self.parent,"New PreAction","PreAction:","add",itemList,True,None)
            
            insertDialog.exec_()
            
            result = insertDialog.getResult()
            if not result == None and len(result) > 0:
                contains = False
                for action in self.exSentence.getPreActionList():
                    if action.getAction() == result:
                        contains = True
                if not contains:
                    self.exSentence.addPreAction(Action(result,Action.PREACTION,order=self.PreActionList.count()))
                    
                    self.updateScreen()
        return function
    
    def removePreAction(self):
        def function():
            indexes = self.PreActionList.selectedIndexes()
            
            preActions = self.exSentence.getPreActionListOrdered()
            
            for index in indexes:
                action = preActions[index.row()]
                self.engine.removeAction(self.sentenceIndex,action.getId(),action.getKind())
                    
        return function
    
    def refillPreActionList(self):
        self.PreActionList.clear()
        for action in self.exSentence.getPreActionListOrdered():
            self.PreActionList.addItem(action.getAction())
    
    def preActionUp(self):
        def function():
                   
            actions = self.exSentence.getPreActionListOrdered()
            indexes = self.PreActionList.selectedIndexes()
            if len(indexes) > 0:
                actionId = actions[indexes[0].row()].getId()
                counter = 1
                while(counter < len(actions)):
                    if actions[counter].getId() == actionId:
                        if counter-1 < len(actions):
                            swapOrder = actions[counter].getOrder()
                            actions[counter].setOrder(actions[counter-1].getOrder())
                            actions[counter-1].setOrder(swapOrder)
                            
                            if swapOrder == actions[counter].getOrder():
                                actions[counter].setOrder(actions[counter].getOrder()+1)
                            
                            
                    counter += 1
                
                self.updateScreen()
                
        return function
    
    def preActionDown(self):
        def function():
                   
            actions = self.exSentence.getPreActionListOrdered()
            indexes = self.PreActionList.selectedIndexes()
            if len(indexes) > 0:
                actionId = actions[indexes[0].row()].getId()
                counter = 0
                while(counter < len(actions)):
                    if actions[counter].getId() == actionId:
                        if counter+1 < len(actions):
                            swapOrder = actions[counter].getOrder()
                            actions[counter].setOrder(actions[counter+1].getOrder())
                            actions[counter+1].setOrder(swapOrder)
                            
                            if swapOrder == actions[counter].getOrder():
                                actions[counter].setOrder(actions[counter].getOrder()-1)
                            
                            
                    counter += 1
                
                self.updateScreen()
        return function
    
    def newPostAction(self):
        def function():
            itemList = self.engine.getAllActions()
            insertDialog = insertDialogWindow(self.parent,"New PostAction","PostAction:","add",itemList,False,None)
            
            insertDialog.exec_()
            
            result = insertDialog.getResult()
            if not result == None and len(result) > 0:
                self.exSentence.addPostAction(Action(result,Action.POSTACTION,order=self.PostActionList.count()))
                
                self.updateScreen()
        return function
    
    def existingPostAction(self):
        def function():
            itemList = self.engine.getAllActions()
            insertDialog = insertDialogWindow(self.parent,"New PostAction","PostAction:","add",itemList,True,None)
            
            insertDialog.exec_()
            
            result = insertDialog.getResult()
            if not result == None and len(result) > 0:
                contains = False
                for action in self.exSentence.getPostActionList():
                    if action.getAction() == result:
                        contains = True
                if not contains:
                    self.exSentence.addPostAction(Action(result,Action.POSTACTION,order=self.PostActionList.count()))
                    
                self.updateScreen()
        return function
    
    def removePostAction(self):
        def function():
            indexes = self.PostActionList.selectedIndexes()
            
            postActions = self.exSentence.getPostActionListOrdered()
            
            for index in indexes:
                action = postActions[index.row()]
                self.engine.removeAction(self.sentenceIndex,action.getId(),action.getKind())
                
            
        return function
    
    def refillPostActionList(self):
        self.PostActionList.clear()
        for action in self.exSentence.getPostActionListOrdered():
            self.PostActionList.addItem(action.getAction())
    
    def postActionUp(self):
        def function():
                   
            actions = self.exSentence.getPostActionListOrdered()
            indexes = self.PostActionList.selectedIndexes()
            if len(indexes) > 0:
                actionId = actions[indexes[0].row()].getId()
                counter = 1
                while(counter < len(actions)):
                    if actions[counter].getId() == actionId:
                        if counter-1 < len(actions):
                            swapOrder = actions[counter].getOrder()
                            actions[counter].setOrder(actions[counter-1].getOrder())
                            actions[counter-1].setOrder(swapOrder)
                            
                            if swapOrder == actions[counter].getOrder():
                                actions[counter].setOrder(actions[counter].getOrder()+1)
                            
                            
                    counter += 1
                
                self.updateScreen()
                
        return function
    
    def postActionDown(self):
        def function():
                   
            actions = self.exSentence.getPostActionListOrdered()
            indexes = self.PostActionList.selectedIndexes()
            if len(indexes) > 0:
                actionId = actions[indexes[0].row()].getId()
                counter = 0
                while(counter < len(actions)):
                    if actions[counter].getId() == actionId:
                        if counter+1 < len(actions):
                            swapOrder = actions[counter].getOrder()
                            actions[counter].setOrder(actions[counter+1].getOrder())
                            actions[counter+1].setOrder(swapOrder)
                            
                            if swapOrder == actions[counter].getOrder():
                                actions[counter].setOrder(actions[counter].getOrder()-1)
                            
                            
                    counter += 1
                
                self.updateScreen()
        return function
    
    def updateScreen(self):
        #if root node make self white
        if self.exSentence.isRootNode():
            self.setStyleSheet("QFrame { background-color:  rgb(255,255,255 ) }")
        
        #color TitleWidget
        r ,g ,b, a = self.engine.getActorList().getActorColor(self.exSentence.getActor()).getRgb()
        self.TitleWidget.setStyleSheet("QWidget { background-color:  rgb("+str(r)+","+str(g)+" ,"+str(b)+" ) }")
        
        #Fill in actor combobox
        self.ActorComboBox.clear()
        currentActor = self.exSentence.getActor()
        actorList = self.engine.getActorList().getActorList()
        if currentActor == None:
            currentActor = ""
        self.ActorComboBox.addItem(currentActor)
        self.ActorComboBox.addItems(actorList)
        self.ActorComboBox.addItem("<new>")
        
        #fill Action lists
        self.refillPreActionList()
        self.refillPostActionList()
        
        #set texts
        self.infoPlaceholder.setText("p: "+str(len(self.exSentence.getParents()))+" id: "+str(self.exSentence.getId()))
        self.update()